#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <utility>

using namespace std;

//    
//    (.h) 

//     ,  FIRST  FOLLOW
ostream & operator << (ostream &stream, const set<string> &terminals);

class Grammar{
private:
	map<string, vector<vector<string>>> grammar; //    :  - ,  -    ,    -   (/)
	map<string, set<string>> FIRSTForG; //     FIRST      :  - /,  -  
	map<string, set<string>> FOLLOWForG; //     FOLLOW    :  - ,  -  
	bool initFIRSTWithTerminalsAndEpsilon();
	bool initFIRSTWithNonTerminals();
	bool initFOLLOW();
	bool calculateFOLLOW();

public:
	Grammar();
	~Grammar();
	bool loadGrammar(istream & stream);
	void printFIRST(ostream & stream);
	set<string> FIRST(const vector<string>&);
	set<string> FOLLOW(const string&);
};

ostream & operator << (ostream & stream, const Grammar &g);

//   
//   .cpp 
Grammar::Grammar(){
	//  -     
	//      ,    - 
	return;
}

Grammar::~Grammar(){
	//  -     
	//     ,    - 
	return;
}

bool Grammar::loadGrammar(istream & stream){
	//    5.1.1
	// 1.       grammar
	// 2.    ,   false

	if (!initFIRSTWithTerminalsAndEpsilon()) return false;
	if (!initFIRSTWithNonTerminals()) return false;
	if (!calculateFOLLOW()) return false;

	return true;
}

ostream & operator << (ostream & stream, const Grammar &g){
	//    5.1.1
}

bool Grammar::initFIRSTWithTerminalsAndEpsilon(){
	//    5.1.2
	//    ,  true,  - false
	return true;
}

void Grammar::printFIRST(ostream &stream){
	//    5.1.2
}

set<string> Grammar::FIRST(const vector<string>& str){
	set<string> result;
	
	//    5.1.3
	
	return result;
}

bool Grammar::initFIRSTWithNonTerminals(){
	//    5.1.4
	//    ,  true,  - false
	return true;
}

bool Grammar::initFOLLOW(){
	//    5.2.1
	//    ,  true,  - false
	return true;
}

bool Grammar::calculateFOLLOW(){
	initFOLLOW();

	//    5.2.2
	//    ,  true,  - false

	return true;
}

set<string> Grammar::FOLLOW(const string& N){
	set<string> result;
	
	//    5.2.3
	
	return result;
}

ostream & operator << (ostream &stream, const set<string> &terminals){
	set<string>::iterator p = res.begin();
	stream << "[";
	while (p != res.end()){
		stream << p->c_str();
		p++;
		if (p != res.end()) stream << " ";
	}
	stream << "]" << endl;
	
	return stream;
}

//  
int main(){
	Grammar G = Grammar();
	G.loadGrammar(ifstream("grammar.txt"));

	//  FIRST
	vector<string> alpha;
	alpha.push_back("E");
	cout << G.FIRST(alpha);
	alpha.clear();
	
	alpha.push_back("E'");
	cout << G.FIRST(alpha);
	alpha.clear();

	alpha.push_back("T");
	cout << G.FIRST(alpha);
	alpha.clear();

	alpha.push_back("T'");
	cout << G.FIRST(alpha);
	alpha.clear();

	alpha.push_back("F");
	cout << G.FIRST(alpha);
	alpha.clear();

	alpha.push_back(")");
	cout << G.FIRST(alpha);
	alpha.clear();

	alpha.push_back("id");
	cout << G.FIRST(alpha);
	alpha.clear();

	//  FOLLOW
	cout << G.FOLLOW(string("E"));
	cout << G.FOLLOW(string("E'"));
	cout << G.FOLLOW(string("T"));
	cout << G.FOLLOW(string("T'"));
	cout << G.FOLLOW(string("F"));

	return 0;
}